# Rcb4Class
---
## Overview
近藤科学製RCB4をArduinoから動かすためのライブラリです。
This library is for connecting a Kondo Kagaku RCB4 from an Arudino.


## Description
近藤科学製RCB4(ロボット用コントロールボード)をArduinoで動かすためのライブラリです。  
This library is for connecting a RCB4 (Kondo kagaku robot control board) using Arudino.

Arduinoから
- RCB4内に保存されているのモーションデータを再生
  Motion data preserved by RCB4 is played.

- Rcb4に接続されているサーボモータに角度指令を送ることができる
  Posiotn order can be sent to servo motor which leads to RCB4.

...etc


## Contents
root/
 ├Rcb4ClassV110.zip
 ├Rcb4SoftSerialClassV110.zip
 ├KoCustomSoftSerial.zip
 ├readmeTop.md (this file)
 ├Rcb4Library_forArduino_1_0.pdf (manual)
 └html版_V110  (Class list (See to index.html))

## Requirement
各圧縮されたライブラリの中身のreadme.mdファイルをご覧ください。
Refer to the compressed readme.md files, which are the contents of the library.

## Usage
ライブラリは3つの圧縮ファイルに分かれています。
The library is divided into three compressed files.

使用する状況に応じてライブラリをインポートしてください。
Import the library depending on conditions of use.

* Serial(HardwareSerial)を使う場合
Rcb4Class only

* SoftwareSerialを使う場合
Rcb4Class
Rcb4SoftSerialClass
KoCustomSoftSerial

詳しくは配布フォルダのマニュアル(PDF)をご覧ください。
For details, refer to the manual (PDF) in the folder provided.

RCB4の詳細な仕様が必要な場合は、[RCB-4リファレンスセット Ver.2.2](http://kondo-robot.com/faq/rcb-4-reference-ver-2_2)にRCB4のコマンドリファレンスやファームウェアリファレンスが圧縮されてありますので、ご覧ください。


## Licence
各圧縮されたライブラリの中身のreadme.mdファイルをご覧ください。
Refer to the compressed readme.md files, which are the contents of the library.

## Author
近藤科学株式会社  01/2018
Kondo Kagaku co.,ltd.
近藤科学ホームページ:(<http://kondo-robot.com/>)
