
//
//  @file Rcb4AckTestForHardwareSerial.ino
//  @brief RCB-4  connect confirms program
//  @author Kondo Kagaku Co.,Ltd.
//  @date 2018/01/30
//
////
////  RCB-4とつながっているかハードウェアシリアルで確認します
////　digital 3pin 
////  H:通信成功(connect success)
////  L:通信失敗(connect failure) 
////

#include <Rcb4HardSerialClass.h> 

const byte ACK_CHECK_PIN = 3; 

const long BAUDRATE = 115200;
const int TIMEOUT = 100;

Rcb4HardSerialClass rcb4(&Serial,BAUDRATE,TIMEOUT);  //RCB4Classの定義、HardwareSerial版

void setup() {
  // put your setup code here, to run once:

  pinMode(ACK_CHECK_PIN ,OUTPUT);  //ACK確認を出力するピン設定
  
  if(rcb4.open() == true)    //通信設定およびconfigデータを取得
  {
    digitalWrite(ACK_CHECK_PIN,HIGH);
  }
  else
  {
    digitalWrite(ACK_CHECK_PIN,LOW);
  }

  if(rcb4.checkAcknowledge() == true)   //Ackチェックは念のため
  {
    digitalWrite(ACK_CHECK_PIN,HIGH);
  }
  else
  {
    digitalWrite(ACK_CHECK_PIN,LOW);
  }
  
}

void loop() {
  // put your main code here, to run repeatedly:

  //100ms毎にACKチェックを行い、結果を ACK_CHECK_PINに出力する
  
  if(rcb4.checkAcknowledge() == true)   
  {
    digitalWrite(ACK_CHECK_PIN,HIGH);
  }
  else
  {
    digitalWrite(ACK_CHECK_PIN,LOW);
  }
  delay(100);
  
}
