
/** 
*  @file Rcb4BaseClass.h
* @brief Rcb4 arduino library header file
* @date 2018/01/29
* @version 1.1.0
* @copyright &copy; Kondo Kagaku Co.,Ltd. 2019
*
* @date 2018/01/29 First edition
* @date	2019/01/16@V1.1.0
*			EgetConfig̕sC
*			EmoveRamToComCmdSynchronizememcopy̕sΉ
*
* @mainpage Rcb4BaseClass̊Tv
* ̃Cu͋ߓȊw{bgpRg[{[hArduinoANZXłvOɂȂ܂<br>
* HeartToHeart4 Ver2.2ȍ~ɑΉĂ܂B<br>
* sł́AarduinoiŎg悤ɐ݌vĂ܂B<br>
* gяڍׂ́ALHPB<br>
* <A HREF="http://kondo-robot.com/">http://kondo-robot.com/</A><br>
* s܂AHPQƂɂAB<br>
* BaseClasśARCB4̊{ƂȂ镔LڂĂ܂B
* ʐM̈Ⴂz邽HardwareSerialSoftwareSerialɔhĂ܂B
* 
**/

/* 
* Rcb4BaseClass.h
*
* Created: 2017/06/13 4:34:57
* Author: 5636m_000,T.Nobuhara
*/


#ifndef __RCB4_BASE_CLASS_H__
#define __RCB4_BASE_CLASS_H__

#include "Arduino.h"

/*! @class Rcb4BaseClass
    @brief  RCB4𓮂ߏݒR}h܂Ƃ߂NXłB
    		̃NXx[Xɔh邱ƂŗlXȒʐM`ɑΉł悤ɂȂ܂B
*/
class Rcb4BaseClass
{
//variables
public:
	static constexpr int Version = 220;	//!< o[Wԍ

/**
 * @enum AckType
 * @brief ACK̒l
  */	
	enum AckType: byte
	{
		Ack=0x06,		//!< ACK̒l	(0x06)
		Nack =0x15		//!< NACK̒l	(0x15)
	};

	//R}h̗񋓌^
/**
 * @enum CommandTypes
 * @brief RCB4̃R}h̒`
 */
	enum CommandTypes: byte
	{
		Move            = 0x00,		//!<	Move߂̃R}hl
		Jump            = 0x0B,		//!<	Jump߂̃R}hl
		Call            = 0x0C,		//!<	Call߂̃R}hl
		SingleServo     = 0x0F,		//!<	T[{[^Pɑ΂Ė߂̃R}hl
		ConstFrameServo = 0x10,		//!<	T[{[^ɑ΂ẴR}hl
		ServoParam      = 0x12,		//!<	Xgb`Xs[hύX邽߂̃R}hl
		AckCheck        = 0xFE,		//!<	ACK`FbNp̃R}hl
		None            = 0xFF		//!<	Ȃ
	};
	
	//moveR}hŎgTuR}h)
/**
 * @enum SubMoveCmd
 * @brief moveR}h̃TuR}h̒`
  */
	enum SubMoveCmd: byte
	{
		RamToCom     = 0x20,	//!< RAM̒lCOM
		ComToRam     = 0x02,	//!< COM̐lRAM
		DeviceToCom  = 0x21,	//!< Device(ICS)̒lCOM
		ComToDevice  = 0x12,	//!< COM̐lDevice(ICS)
	};
	
	//RAMɕۑĂ擪AhXꗗ
/**
 * @enum RamAddr
 * @brief RAMɕۑĂAhẌꗗ
  */
	enum RamAddr: unsigned short
	{
		ConfigRamAddress         = 0x0000,		//!< VXeݒRAMAhX(RAM)i0x00Œj
		ProgramCounterRamAddress = 0x0002,		//!< vOJE^[ݒAhX(RAM)i0x02Œj
		AdcRamAddress            = 0x0022,		//!< ADϊ0̒l̃AhX(0x22Œ)
		PioModeAddres			 = 0x0038,		//!< PIO̓o͐ݒ 
		PioAddress               = 0x003A,		//!< PIO|[gl
		KrrButtonDataAddress     = 0x0350,		//!< KRR̃{^f[^L^ĂAhX
		KrrPa1Address            = 0x0352,		//!< PA1f[^(̌2bytef[^)
		//StartupCmdRomAddress     = 0x0444,	//!< X^[gAbv[VĐR}h̃AhX
		//MainLoopCmd              = 0x044B		//!< C[vŏ̃AhX

	};
	
	
	
	//ROMɕۑĂ擪AhXꗗ)
/**
 * @enum RomAddr
 * @brief ROMɕۑĂAhẌꗗ
  */
	enum RomAddr: long
	{
		StartupCmdRomAddress = 0x0444,		//!< X^[gAbv[VĐR}h̃AhX
		MainLoopCmd = 0x044B,				//!< C[vŏ̃AhX
		MotionRomAddress = 0x0b80
	};
	
	static constexpr int AdcCount = 11;								//!< ADϊ̃`l)
	static constexpr int AdcSingleDataCount = 2;						//!< ADϊP̂̃f[^oCg
	static constexpr int AdcDataCount = AdcCount * AdcSingleDataCount;	//!< ADϊŜ̃f[^oCg

	//foCXAhX̃ItZbg̒`(AhXǂꂭ炢Ă邩)
/**
 * @enum DeviceAddrOffset
 * @brief (ICS)foCX̐ݒli[Ăe擪̃AhX̏
 */
	enum DeviceAddrOffset:byte
	{
		CategoryAddressOffset      = 0x00,		//!< VXeݒRAMAhX(RAM)i0x00Œj
		IDAddressOffset            = 0x01,		//!< RAMAROMIDf[^̈ʒu
		TrimAddressOffset          = 0x02,		//!< RAMAROM̃gf[^̈ʒu
		MotorPositionAddressOffset = 0x04,		//!< RAMAROM̎lf[^̈ʒu
		PositionAddressOffset      = 0x06,		//!< RAMAROM̃|WVf[^̈ʒu
		frameAddressOffset         = 0x08,		//!< RAMAROM̃t[f[^iԑxEXs[hj̈ʒu
		Mixing1AddressOffset       = 0x0E,		//!< (14)RAMAROM̃~LVOPf[^̈ʒu
		Mixing1RatioAddressOffset  = 0x10,		//!< (16)RAMAROM̃~LVOP{f[^̈ʒu
		Mixing2AddressOffset       = 0x11,		//!< (17)RAMAROM̃~LVO2f[^̈ʒu
		Mixing2RatioAddressOffset  = 0x13		//!< (19)RAMAROM̃~LVO2f[^̈ʒu
	};

	//SIOԍ̒`
/**
 * @enum SioNum
 * @brief SioRlN^̔ԍ̒`
 */
	enum SioNum:byte
	{
		SIO1_4 = 0x01,		//!< SIO1-4l
		SIO5_8 = 0x02		//!< SIO5-8l
	};

	//KRRp̃{^̒`
/**
 * @enum KRR_BUTTON
 * @brief KRRM{^f[^̒`
 * @brief ̏ꍇ͊ef[^̘_aƂ܂
 */
	enum KRR_BUTTON : unsigned short
	{
		KRR_BUTTON_NONE     = 0x0000,		//!<	ĂȂ
		KRR_BUTTON_UP       = 0x0001,		//!<	
		KRR_BUTTON_DOWN     = 0x0002,		//!<	
		KRR_BUTTON_RIGHT    = 0x0004,		//!<	
		KRR_BUTTON_LEFT     = 0x0008,		//!<	
		KRR_BUTTON_TRIANGLE = 0x0010,		//!<	
		KRR_BUTTON_CROSS    = 0x0020,		//!<	~
		KRR_BUTTON_CIRCLE   = 0x0040,		//!<	
		KRR_BUTTON_SQUARE   = 0x0100,		//!<	
		KRR_BUTTON_S1       = 0x0200,		//!<	Vtg1 O
		KRR_BUTTON_S2       = 0x0400,		//!<	Vtg2 
		KRR_BUTTON_S3       = 0x0800,		//!<	Vtg3 EO
		KRR_BUTTON_S4       = 0x1000,		//!<	Vtg4 E
		KRR_BUTTON_FALSE    = 0xFFFF		//!<	G[l(Ms)
	};
	static constexpr int	MotionSingleDataCount = 2048;	//!< 1[Ṽf[^oCg
	static constexpr int	MaxMotionCount = 120;			//!< [V̍ő吔)
	static constexpr long	MotionDataCount = 2048 * 120;	//!< [Vf[^Ŝ̍őoCg

/**
 * @struct ServoData
 * @brief T[{[^IDSIOƃ|WV̉f[^i[܂B
 * @brief T[{[^𓮂p[^ς肵܂
 */
	struct ServoData
	{
		byte	Id;		//!< ICS@IDԍ̊i[ꏊ
		byte	Sio;	//!< sio̔ԍ(1 or 2)
		int		Data;	//!< |WVf[^₻̑f[^
	};
	
	

public:

	
/**
 * @union ConfigData
 * @brief 2bytẽRtBOf[^eՂɃANZXł悤p̂ɂ܂
 */
typedef union {
			/// rbgtB[\
			/* @struct bit
				@brief eڂwł܂
			*/
			struct {
				byte EnableSio :1;				//!< b0:ICSXCb`
				byte EnableRunEeprom :1;		//!< b1: EEPROMvOsXCb`
				byte EnableServoResponse :1;	//!< b2: ԓIbZ[WXCb`
				byte EnableReferenceTable :1;	//!< b3:xN^WvXCb`
				byte Frame :2;					//!< b4, b5 o͎WX^[4:5]
				byte Baudrate :2;				//!< b6, b7 COM{[[gWX^[6:7]ƂԂȂmF
				byte ZeroFlag :1;				//!< b8 [tO
				byte CarrayFlag :1;				//!< b9 L[tO
				byte ProgramError :1;			//!< b10 vOG[tO
				byte RFU :1;					//!< b11,b12 gp
				byte IcsBaudrate :2;			//!< b13,b14 ICSXCb`{[[gWX^[13:14] ƂԂȂmF
				byte GreenLED :1;				//!< b15 LEDWX^
			} bit;
			/// WORD(2oCg)f[^1oCgƂɕĎgp
			/* @struct byte
				@brief bytePʂŃANZXł܂
			*/
			struct {
				byte low;						//!< low 8 bit
				byte high;						//!< high 8 bit
			} byte;
			unsigned short word;				//!< 16rbgWORDf[^(ConfigDataxɃANZXł悤)
		} ConfigData;
		
ConfigData configData;	//!< RtBOf[^̊i[ꏊ 

protected:


/**
 * @union WordByte
 * @brief 2byte(short^)̃f[^ANZXł悤p̂ɂ܂
 */
	typedef	union {
		uint8_t		byte[2];	//!< byte x2
		uint16_t	word;		//!< WordByte(short)
	} WordByte;

/**
 * @union DwordByte
 * @brief 4byte(long^)̃f[^ANZXł悤p̂ɂ܂
 */
	typedef	union {
		uint8_t		byte[4];	//!< byte x4
		uint16_t	word[2];	//!< WordByte(short) x2
		uint32_t	dword;		//!< DoubleWord(long)
	} DwordByte;
/**
 * @union QwordByte
 * @brief 8byte(long long^)̃f[^ANZXł悤p̂ɂ܂
 */
	typedef	union {
		uint8_t		byte[8];	//!< byte x8
		uint16_t	word[4];	//!< WordByte(short) x4
		uint32_t	dword[2];	//!< DoubleWord(long) x2
		uint64_t	qword;		//!< QuadWord(long long)
	} QwordByte;


protected:

	byte txBuf[128];	//!< Mpobt@	
	byte rxBuf[128];	//!< Mpobt@


	
	//ʐMptO ݑM(synchronize)f܂ 
	//true:s   false:ҋ@
	bool _isSynchronize = false;	//!< ݑM(synchronize)f܂ true:s   false:ҋ@
	
	

private:

//functions
public:

/**
*	@brief ʐMǂԂ֐
*	@retval true M
*	@retval false ҋ@
*/
	bool isSynchronize(){return _isSynchronize;}			// (get̂, set̓NXł̂݉\)

	bool getConfig(unsigned short *confData);
	bool getConfig();

	//command֐

	int moveComToRamCmd(byte *txData,int destAddr,byte destData[],int destDataSize);
	int moveComToRamCmd(int destAddr,byte destData[],int destDataSize);
	
	int moveRamToComCmd(byte *txData,int scrAddr,int scrDataSize);
	int moveRamToComCmd(int scrAddr,int scrDataSize);

	int moveComToDeviceCmd (byte *txData,byte idNum,byte sioNum,byte offset,int data);
	int moveComToDeviceCmd (byte idNum,byte sioNum,byte offset,int data);
	int moveComToDeviceCmd (byte *txData,byte icsNum,byte offset,int data);
	int moveComToDeviceCmd (byte icsNum,byte offset,int data);

	int moveDeviceToComCmd(byte *txData,byte idNum,byte sioNum,byte offset,byte dataSize);
	int moveDeviceToComCmd(byte idNum,byte sioNum, byte offset, byte dataSize);
	int moveDeviceToComCmd(byte *txData,byte icsNum,byte offset,byte dataSize);
	int moveDeviceToComCmd(byte icsNum, byte offset, byte dataSize);
	
	int callCmd(byte *txData,long romAddr);
	int callCmd(long romAddr);

	int runSingleServoCmd (byte *txData,ServoData servoData,byte frame);
	int runSingleServoCmd (ServoData servoData,byte frame);

	int runSingleServoCmd (byte *txData,byte idNum,byte sioNum,int pos,byte frame);
	int runSingleServoCmd (byte idNum,byte sioNum,int pos,byte frame);
	
	
	
	int runConstFrameServoCmd (byte *txData,ServoData servoDatas[],byte servoCount,byte frame);
	int runConstFrameServoCmd (ServoData servoData[],byte servoCount,byte frame);

	int setParametersBaseCmd (byte *txData, byte servoParameter,ServoData servoDatas[],byte servoCount);
	int setParametersBaseCmd (byte servoParameter,ServoData servoData[],byte servoCount);

	int setSpeedCmd (byte *txData,ServoData servoDatas[],byte servoCount);
	int setSpeedCmd (ServoData servoData[],byte servoCount);

	int setStretchCmd (byte *txData,ServoData servoDatas[],byte servoCount);
	int setStretchCmd (ServoData servoData[],byte servoCount);

	int acknowledgeCmd (byte *txData);
	int acknowledgeCmd ();


//f[^M (\[Xɖ̂ŋL)///////////////////////////////////////////////////////////////////
/**
* @brief ICSʐM̑M
* @param[in,out] *txBuf
* @param[in] txLen
* @param[out] *rxBuf Mi[obt@
* @param[in] rxLen  Mf[^
* @retval true ʐM
* @retval false ʐMs
* @attention C^[tFCXAqNXŒ`邱
* @attention Mf[^AMf[^̓R}hɂĈႤ̂Œӂ
* 
**/
	virtual bool synchronize(byte txBuf[],byte txLen,byte rxBuf[],byte rxLen);	//C^[tFCXAqNXŒ`邱
	
	bool checkAcknowledge();
	bool setCheckSum(byte dataBytes[]);
	bool checkCheckSum(byte dataBytes[]);
	bool checkReverceCmd(byte dataBytes[],byte cmd);


	unsigned short getPio();
	bool setPio (unsigned short pioData);
	unsigned short getPioMode ();
	bool setPioMode (unsigned short pioModeData);

	unsigned short getAdData(int adPort);
	bool getAllAdData(int	adDatas[11]);

	bool setKrrData (unsigned short buttonData, byte adData[4]);
	bool setKrrButtonData (unsigned short buttonData);
	bool setKrrAdData (byte paPort, byte adData);



	bool setSingleServo (byte id, byte sio,int pos,byte frame);
	bool setSingleServo (ServoData servoData,byte frame);
	bool setFreeSingleServo (byte id, byte sio);
	bool setHoldSingleServo (byte id, byte sio);
	
	bool setServoPos (ServoData servoDatas[],byte servoCount,byte frame);
	bool setFreePos (ServoData servoDatas[],byte servoCount);
	bool setHoldPos (ServoData servoDatas[],byte servoCount);
	
	int getSinglePos(byte id,byte sio);
	
	bool setServoSpeed (ServoData servoDatas[],byte servoCount);
	bool setServoStretch (ServoData servoDatas[],byte servoCount);
	
	byte icsNum2id(byte id,byte sio);
	
	
	
	
	bool motionPlay(int motionNum);
	bool suspend();
	bool suspend(unsigned short *config);
	bool setMotionNum(byte motionNum);
	bool resetProgramCounter();

	bool resume (unsigned short *configData);
	bool resume ();
	
	long motionAddr2motionNum(byte motionNum);

protected:

	//Rcb4BaseClass( const Rcb4BaseClass &c );
	//Rcb4BaseClass& operator=( const Rcb4BaseClass &c );
	byte	CheckSum(byte dataBytes[]);
	bool	checkuning(byte *txData);
	int64_t	setServoNo (ServoData servoDatas[],byte servoCount);
	bool sortServoDatas(ServoData servoDatas[],byte ServoCount);
	
	unsigned short moveRamToComCmdSynchronize(int scrAddr,byte scrDataSize,byte	rxDara[]);
	bool	moveComToRamCmdSynchronize(int scrAddr,byte destData[],int destDataSize);
	bool	SynchronizeAck(byte	*txData);
	

	
private:

}; //Rcb4BaseClass

#endif //__RCB4_BASE_CLASS_H__