
/** 
*  @file Rcb4HardSerialClass.cpp
* @brief  Rcb4 arduino (HardwareSerial) library
* @author Kondo Kagaku Co.,Ltd.
* @author T.Nobuhara
* @date 2018/01/29
* @version 1.1.0
* @copyright Kondo Kagaku Co.,Ltd. 2018
* 
* @date 2019/01/16 V1.1.0 Rcb4BaseClasŝݏC߃o[WグĂ
*
**/	
/* 
* Rcb4SoftSerialClass.cpp
*
* Created: 2017/06/13 4:34:57
* Author: 5636m_000,T.Nobuhara
*/

#include "Rcb4HardSerialClass.h"

/**
*	@brief RXgN^
**/
Rcb4HardSerialClass::Rcb4HardSerialClass()
{
	rcbHardSerial = &Serial;
	g_timeout = 1000;
	
	
} 



/**
*	@brief RXgN^
*	@param[in] *rcb4Serial RCB4ɐݒ肷UART(HardwareSerial^̃|C^)
**/
Rcb4HardSerialClass::Rcb4HardSerialClass(HardwareSerial *rcb4Serial)
{
	rcbHardSerial = rcb4Serial;
	g_timeout = 1000;
}


/**
*	@brief RXgN^
*	@param[in] *rcb4Serial RCB4ɐݒ肷UART(HardwareSerial^̃|C^)
*	@param[in] baudrate T[{̒ʐMx
*	@param[in] timeout M^CAEg(ms)
**/
Rcb4HardSerialClass::Rcb4HardSerialClass(HardwareSerial *rcb4Serial, long baudrate, int timeout)	
{
	rcbHardSerial = rcb4Serial;
	g_timeout = timeout;
	g_baudrate = baudrate;
}



/**
* @brief fXgN^
* @post gpĂrcbHardSerialJ܂
**/
Rcb4HardSerialClass::~Rcb4HardSerialClass()
{
  if (rcbHardSerial)  //`ĂSerial
  {
    rcbHardSerial->end();
  }

} //~Rcb4SoftSerialClass



///////////////////////////////////////////////////////////////////////////////////
//ʐM̏Aack,p[^擾)
/**
* @brief ʐM̏ݒ
* @retval true ʐMݒ芮
* @retval false ʐMݒ莸s
* @details ʐM̏ݒs܂
		ɁARCB4̒ʐM`FbNconfigf[^擾܂
* @attention Serial̐ݒAʐMxA^CAEg͎Oɐݒ肵Ă鎖
**/
bool Rcb4HardSerialClass::open()
{	
	return open(rcbHardSerial,g_baudrate,g_timeout);
}



/**
*	@brief ʐM̏ݒ
*	@param[in] *rcb4Serial RCB4ɐݒ肷UART(HardwareSerial^̃|C^)
*	@param[in] baudrate T[{̒ʐMx
*	@param[in] timeout M^CAEg(ms)
*	@retval true ʐMݒ芮
*	@retval false ʐMݒ莸s
*	@details ʐM̏ݒs܂
		ɁARCB4̒ʐM`FbNconfigf[^擾܂
* @attention Serial̐ݒAʐMxA^CAEg͎Oɐݒ肵Ă鎖
**/
bool Rcb4HardSerialClass::open(HardwareSerial *rcb4Serial, long baudrate, int timeout)
{
	g_baudrate = baudrate;						//ʐMxNX̕ϐɑ
	rcbHardSerial = rcb4Serial;					//SerialNX̕ϐɊ蓖
	g_timeout = timeout;						//^CAEglNX̕ϐɑ

	if(rcbHardSerial == nullptr)				//rcbHardSerial`ĂȂ甲
	{
		return false;
	}

	rcbHardSerial->begin(baudrate,SERIAL_8E1);	//Serial̐ݒAJn
	rcbHardSerial->setTimeout(g_timeout);		//^CAEg̐ݒ
	

	if(checkAcknowledge() == false)
	{
		return false;
  	}
	else
	{
		delay(100);
		return getConfig();
	}
	

}



/**
*	@brief ʐM̏ݒ
*	@param[in] baudrate T[{̒ʐMx
*	@param[in] timeout M^CAEg(ms)
*	@retval true ʐMݒ芮
*	@retval false ʐMݒ莸s
*	@details ʐM̏ݒs܂
		ɁARCB4̒ʐM`FbNconfigf[^擾܂
* @attention Serial̐ݒ͎Oɐݒ肵Ă鎖
**/
bool Rcb4HardSerialClass::open(long baudrate, int timeout)
{
	return open(rcbHardSerial,baudrate,timeout);
}



//////////////////////////////////////////////////////////////////////////////////////////
//ʐM֌W

//ۂɑMs
/**
* @brief RCB-4Ƃ̑M
* @param[in,out] *txBuf
* @param[in] txLen
* @param[out] *rxBuf Mi[obt@
* @param[in] rxLen  Mf[^
* @retval true ʐM
* @retval false ʐMs
* @attention Mf[^AMf[^̓R}hɂĈႤ̂Œӂ
**/
bool Rcb4HardSerialClass::synchronize(byte txBuf[],byte txLen,byte rxBuf[],byte rxLen)
{

	//_isSynchronize = true;				
	if (rcbHardSerial != nullptr)			//rcbHardSerial`Ă邩mF
	{

		_isSynchronize = true;				//݃tOݒɂĂ
		rcbHardSerial->flush();				//xobt@NA

		for(byte i = 0; i < txLen; i++)		//w̃oCg
		{
			rcbHardSerial->write(txBuf[i]);
		}

		//rcbHardSerial->setTimeout(g_timeout);
		if(rcbHardSerial->readBytes(rxBuf,rxLen) == rxLen)		//woCg󂯎
		{
			_isSynchronize = false;						//
			
			//2018/12/25@SoftSerial̎Mf[^Ńf[^ԂĂȂƂ̂ŁAǋL
			if(rxLen != rxBuf[0])
			{
				return	false;
			}
						
			return checkReverceCmd(rxBuf,txBuf[1]);		//R}h`FbN
		}
		else
		{	//ѱ
			_isSynchronize = false;						//s
			return	false;
		}
	}
	else			//`ĂȂ̏
	{
		return false;
	}

	return true;
}




