
/** 
*  @file Rcb4HardSerialClass.h
* @brief  Rcb4 arduino (HardwareSerial) library header file
* @author Kondo Kagaku Co.,Ltd.
* @author T.Nobuhara
* @date 2018/01/29
* @version 1.1.0
* @copyright Kondo Kagaku Co.,Ltd. 2018
**/	

/* 
* Rcb4BaseClass.h
*
* Created: 2017/06/13 4:34:57
* Author: 5636m_000,T.Nobuhara
*/

#ifndef __RCB4_HARD_SERIAL_CLASS_H__
#define __RCB4_HARD_SERIAL_CLASS_H__

#include "Arduino.h"

#include "HardwareSerial.h"
#include "Rcb4BaseClass.h"


/*! @class Rcb4HardSerialClass
    @brief  Rcb4BaseClasshArduinoSerial(HardwareSerial)oRRCB4ƒʐMs܂B
*/
class Rcb4HardSerialClass : public Rcb4BaseClass
{
//variables
public:

protected:
	HardwareSerial		*rcbHardSerial;			//!<	ʐMgp邽߂̃|C^ϐ

	int		g_timeout = 1000;				//!<	^CAEg̐ݒ
	long	g_baudrate = 115200;			//!<	ʐMx̐ݒ 	


private:

//functions
public:
	Rcb4HardSerialClass();
	Rcb4HardSerialClass(HardwareSerial *rcb4Serial);
	Rcb4HardSerialClass(HardwareSerial *rcb4Serial, long baudrate, int timeout);
	~Rcb4HardSerialClass();

	virtual bool open();
	virtual bool open( long baudrate, int timeout);
	bool open(HardwareSerial *rcb4Serial, long baudrate, int timeout);

	virtual bool synchronize(byte txBuf[],byte txLen,byte rxBuf[],byte rxLen);

}; //Rcb4HardSerialClass

#endif //__RCB4_HARD_SERIAL_CLASS_H__
