
/** 
*  @file Rcb4SoftSerialClass.cpp
* @brief  Rcb4 arduino (SoftwareSerial) library
* @author Kondo Kagaku Co.,Ltd.
* @author T.Nobuhara
* @date 2019/01/16
* @version 1.1.0
* @copyright Kondo Kagaku Co.,Ltd. 2019
**/		
/* 
* Rcb4SoftSerialClass.cpp
*
* Created: 2017/06/13 4:34:57
* Author: 5636m_000,T.Nobuhara
*/


#include "Rcb4SoftSerialClass.h"
#include "KoCustomSoftSerial.h"

/**
*	@brief RXgN^
**/
Rcb4SoftSerialClass::Rcb4SoftSerialClass()
{
	rcb4SoftSerial = nullptr;
} //Rcb4Class


/**
*	@brief RXgN^
*	@param[in] rxPin	Ms
*	@param[in] txPin	Ms
*	@details sݒł炢AVKKoCustomSoftSerial쐬܂
**/
Rcb4SoftSerialClass::Rcb4SoftSerialClass(byte rxPin,byte txPin)
{
	g_timeout = 1000;
	rcb4SoftSerial = new KoCustomSoftSerial(rxPin,txPin);
	rcb4SoftSerial->setTX(txPin);
	rcb4SoftSerial->setRX(rxPin);

}



/**
*	@brief RXgN^
*	@param[in] rxPin	Ms
*	@param[in] txPin	Ms
*	@param[in] baudrate T[{̒ʐMx
*	@param[in] timeout M^CAEg(ms)
*	@details sݒł炢AVKKoCustomSoftSerial쐬܂
**/
Rcb4SoftSerialClass::Rcb4SoftSerialClass(byte rxPin,byte txPin, long baudrate, int timeout)
{
	g_timeout = timeout;
	g_baudrate = baudrate;
	rcb4SoftSerial = new KoCustomSoftSerial(rxPin,txPin);
	rcb4SoftSerial->setTX(txPin);
	rcb4SoftSerial->setRX(rxPin);

}



/**
*	@brief RXgN^
*	@param[in] *rcb4KoSoftSerial RCB4ɐݒ肷UART(SoftwareSerial^̃|C^)
**/
Rcb4SoftSerialClass::Rcb4SoftSerialClass(KoCustomSoftSerial *rcb4KoSoftSerial)
{
	g_timeout = 1000;
	rcb4SoftSerial =rcb4KoSoftSerial;

}



/**
*	@brief RXgN^
*	@param[in] *rcb4KoSoftSerial RCB4ɐݒ肷UART(SoftwareSerial^̃|C^)
*	@param[in] baudrate T[{̒ʐMx
*	@param[in] timeout M^CAEg(ms)
**/
Rcb4SoftSerialClass::Rcb4SoftSerialClass(KoCustomSoftSerial *rcb4KoSoftSerial, long baudrate, int timeout)
{
	
	rcb4SoftSerial = rcb4KoSoftSerial;
	g_timeout = timeout;
	g_baudrate = baudrate;
	//rcb4SoftSerial->begin(baudrate);

}
/**
* @brief fXgN^
* @post ɉ܂
**/
Rcb4SoftSerialClass::~Rcb4SoftSerialClass()
{

} //~Rcb4SoftSerialClass


///////////////////////////////////////////////////////////////////////////////////
//ʐM̏Aack,p[^擾)
//
/**
*	@brief ʐM̏ݒ
*	@retval true ʐMݒ芮
*	@retval false ʐMݒ莸s
*	@details ʐM̏ݒs܂
		ݒ͓ϐrcb4SoftSerialAg_timeoutAg_baudrategp܂
		ɁARCB4̒ʐM`FbNconfigf[^擾܂
* @attention Serial̐ݒAʐMxA^CAEg͎Oɐݒ肵Ă鎖
**/
bool Rcb4SoftSerialClass::open()
{
	if(rcb4SoftSerial == nullptr)		//VA`ĂȂG[
	{
		return false;
	}
	
	rcb4SoftSerial->begin(g_baudrate,SERIAL_8E1);	//ʐMݒ
	
	if(checkAcknowledge() == false)		//RCB4Ɛڑ(ACK)̃`FbN
	{				
		return false;					//sĂG[
	}
	else								//ACK`FbN̓RtBOǂ݂ɍs
	{
		delay(100);
		return getConfig();				//RtBOǂ߂ꍇtrueԂ
	}
}



/**
*	@brief ʐM̏ݒ
*	@param[in] *rcb4KoSoftSerial RCB4ɐݒ肷UART(SoftwareSerial^̃|C^)
*	@param[in] baudrate T[{̒ʐMx
*	@param[in] timeout M^CAEg(ms)
*	@retval true ʐMݒ芮
*	@retval false ʐMݒ莸s
*	@details ʐM̏ݒs܂
		ݒp̃p[^ϐɓĂopen()ɓn܂
		ɁARCB4̒ʐM`FbNconfigf[^擾܂
* @attention Serial̐ݒ͎Oɐݒ肵Ă鎖
**/
bool Rcb4SoftSerialClass::open(KoCustomSoftSerial *rcb4KoSoftSerial, long baudrate, int timeout)
{
	rcb4SoftSerial = rcb4KoSoftSerial;
	g_timeout = timeout;
	g_baudrate = baudrate;	
	
	return open();

}

/**
*	@brief ʐM̏ݒ
*	@param[in] baudrate T[{̒ʐMx
*	@param[in] timeout M^CAEg(ms)
*	@retval true ʐMݒ芮
*	@retval false ʐMݒ莸s
*	@details ʐM̏ݒs܂
		ݒp̃p[^ϐɓĂopen()ɓn܂
		ɁARCB4̒ʐM`FbNconfigf[^擾܂
* @attention Serial̐ݒ͎Oɐݒ肵Ă鎖
**/
bool Rcb4SoftSerialClass::open(long baudrate, int timeout)
{
	g_timeout = timeout;
	g_baudrate = baudrate;	
		
	return open();

}



//////////////////////////////////////////////////////////////////////////////////////////
//ʐM֌W

//ۂɑMs
/**
* @brief RCB-4Ƃ̑M
* @param[in,out] *txBuf
* @param[in] txLen
* @param[out] *rxBuf Mi[obt@
* @param[in] rxLen  Mf[^
* @retval true ʐM
* @retval false ʐMs
* @attention Mf[^AMf[^̓R}hɂĈႤ̂Œӂ
* @attention ۂ̑ḾArcb4SoftSerialɊ蓖ĂĂ̂g܂
**/
bool Rcb4SoftSerialClass::synchronize(byte txBuf[],byte txLen,byte rxBuf[],byte rxLen)
{

	
	
	if (rcb4SoftSerial != nullptr)		//Serial^`Ă邩f
	{	
		_isSynchronize = true;
		


		for(byte i = 0; i < txLen; i++)				//M
		{
			rcb4SoftSerial->write(txBuf[i]);
		}

		
		rcb4SoftSerial->flush();		//Mobt@̃NA
		rcb4SoftSerial->set_recv_length(rxLen);		//M̃Zbg
		rcb4SoftSerial->listen();					//擾Jn
			


		uint8_t	ptr = 0;
		unsigned long _startMillis = millis();
		do 											//timeout̂Ƃ̏
		{
		 	if((millis() - _startMillis) >(unsigned long) g_timeout)
		 	{
		 		break;
			}
			ptr = rcb4SoftSerial->available();
						
		} while (ptr == 0 );		//f[^ׂĂ܂܂Ń[v(available()̃f[^Ƃ)


		if( ! ((ptr == 0xFF) || (ptr == 0)) )			//peBG[Ms
		{
			ptr &= 0x7f;									//}CiXɂȂ邱ƂȂ
			
			for (uint8_t	c = 0;	c < rxLen	; c++)		//available()̃f[^Ƃ̂ŎMł܂킷
			{
				rxBuf[c] =rcb4SoftSerial->read();
			}
			
			_isSynchronize = false;
			
			rcb4SoftSerial->flush();	//ׂēǂݏIÔߎMobt@̓NAĂ
			
			//2018/12/25@SoftSerial̎Mf[^Ńf[^ԂĂȂƂ̂ŁAǋL
			if(rxLen != rxBuf[0])
			{				
				return	false;
			}
			
			return checkReverceCmd(rxBuf,txBuf[1]);		//truȅꍇ͂Ŕ
		}
		else
		{	//^CAEgюMs
			rcb4SoftSerial->flush();	//ׂēǂݏIÔߎMobt@̓NAĂ
			_isSynchronize = false;
			return	false;
		}
		
	}
	else				//Serial^`ĂȂ甲
	{
			return false;
	}

	//ʏ͂܂ŗȂ
	
	return true;
}





