
/** 
*  @file Rcb4SoftSerialClass.h
* @brief  Rcb4 arduino (SoftwareSerial) library header file
* @author Kondo Kagaku Co.,Ltd.
* @author T.Nobuhara
* @date 2018/01/29
* @version 1.1.0
* @copyright Kondo Kagaku Co.,Ltd. 2018
*
* @date 2019/01/16 V1.1.0 Rcb4BaseClasŝݏC߃o[WグĂ
*
**/		
/* 
* Rcb4Class.h
*
* Created: 2017/06/13 4:34:57
* Author: 5636m_000,T.Nobuhara
*/


#ifndef __RCB4_SOFT_SERIAL_CLASS_H__
#define __RCB4_SOFT_SERIAL_CLASS_H__

#include "Arduino.h"
#include <KoCustomSoftSerial.h>
#include "Rcb4BaseClass.h"


/*! @class Rcb4SoftSerialClass
    @brief  Rcb4BaseClasshArduinoSerial(SoftwareSerial)oRRCB4ƒʐMs܂B
*/
class Rcb4SoftSerialClass : public Rcb4BaseClass
{
//variables
public:

protected:
	KoCustomSoftSerial *rcb4SoftSerial;		//!<	ʐMgp邽߂̃|C^ϐ
		
	int		g_timeout = 1000;				//!<	^CAEg̐ݒ̊i[ϐ
	long	g_baudrate = 115200;			//!<	ʐMx̐ݒ̊i[ϐ
	

private:

//functions
public:
	Rcb4SoftSerialClass();
	Rcb4SoftSerialClass(byte txPin,byte rxPin);
	Rcb4SoftSerialClass(byte txPin,byte rxPin, long baudrate, int timeout);
	Rcb4SoftSerialClass(KoCustomSoftSerial *rcb4KoSoftSerial);
	Rcb4SoftSerialClass(KoCustomSoftSerial *rcb4KoSoftSerial, long baudrate, int timeout);
	

	~Rcb4SoftSerialClass();

	virtual bool open();
	virtual bool open( long baudrate, int timeout);
	virtual bool open(KoCustomSoftSerial *rcb4KoSoftSerial, long baudrate, int timeout);


	virtual bool synchronize(byte txBuf[],byte txLen,byte rxBuf[],byte rxLen);

protected:


private:
	
	
}; //Rcb4Class

#endif //__RCB4CLASS_H__
